CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  

  _pinGroup = 1
  

  _leftChannelAudioPin = 15
  _rightChannelAudioPin = 14

  _leftChannelVolume = 100
  _rightChannelVolume = 100

  _cardDataOutPin = 0
  _cardClockPin = 1
  _cardDataInPin = 2
  _cardChipSelectPin = 3
  _cardProtectPin = -1 ' -1 if unused.
  _cardDetectPin = -1 ' -1 if unused. 
  
OBJ

  but: "D8C_BUTEngine.spin"
  dac: "PCM2.1_DACEngine.spin"
  fat: "SD3.01_FATEngine.spin"
  rtc: "DS1307_RTCEngine.spin"

PUB audio | xCounter, yCounter, keyboardEvent, keyboardRate
   
  ifnot( dac.DACEngineStart(_leftChannelAudioPin, _rightChannelAudioPin, 0) and {
       } fat.FATEngineStart(_cardDataOutPin, _cardClockPin, _cardDataInPin, _cardChipSelectPin, {
                          } _cardProtectPin, _cardDetectPin, -1, -1, {
                          } -1) )
    reboot

  dac.leftChannelVolume(_leftChannelVolume)
  dac.rightChannelVolume(_rightChannelVolume)

PUB Main
   
 
                                                            
  ifnot but.BUTEngineStart(_pinGroup)                'Starts BUT engine            
    reboot                      

  if but.buttonPressed(12) == true                   'Checks to see if buttons in button group were pressed, if so, performs function
    playWAV(string("Music.WAV"))
    return
          
  elseif but.buttonPressed(13) == true 
    playWAV(string("Music.WAV"))
    return
           
  else
                                                     'exits sequence and continues with program since no buttons were pressed
    return


PRI playWAV(fileName)

  if(playerID)
    cogstop(-1 + playerID~)

  playerDoneFlag := false
  playerID := (cognew(WAVPlayer(fileName), @WAVStack) + 1)

PRI WAVPlayer(fileName)

  fat.mountPartition(0)
  fat.openFile(fileName, "R")

  fat.fileSeek(22)
  dac.numberOfChannelsSetup(fat.readShort)
  dac.sampleRateSetup(fat.readLong)
  fat.fileSeek(34)

  result := fat.readShort
  dac.bitsPerSampleSetup(result)
  dac.sampleSignSetup(result == 16)
  fat.fileSeek(40)

  dac.startPlayer
  repeat (fat.readLong >> 9)
    fat.readData(dac.transferData, 512)

  dac.clearData
  dac.stopPlayer
  fat.unmountPartition

  playerDoneFlag := true
  cogstop(cogid)

DAT WAVDat

playerID           byte 0
playerDoneFlag     byte 0

playerSample       byte 0
playerStore        byte 0

WAVStack           long 0[97]

{{

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}}                                   